﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Xml.Linq;

namespace ThumbServer.My
{
	// Token: 0x02000007 RID: 7
	[DebuggerNonUserCode]
	[CompilerGenerated]
	[EditorBrowsable(EditorBrowsableState.Never)]
	internal sealed class InternalXmlHelper
	{
		// Token: 0x06000011 RID: 17 RVA: 0x00193AA4 File Offset: 0x00191EA4
		[EditorBrowsable(EditorBrowsableState.Never)]
		private InternalXmlHelper()
		{
		}

		// Token: 0x17000006 RID: 6
		// (get) Token: 0x06000012 RID: 18 RVA: 0x00193AB0 File Offset: 0x00191EB0
		// (set) Token: 0x06000013 RID: 19 RVA: 0x00193B10 File Offset: 0x00191F10
		public static string Value
		{
			get
			{
				try
				{
					IEnumerator<XElement> enumerator = source.GetEnumerator();
					if (enumerator.MoveNext())
					{
						XElement xelement = enumerator.Current;
						return xelement.Value;
					}
				}
				finally
				{
					IEnumerator<XElement> enumerator;
					bool flag = enumerator != null;
					if (flag)
					{
						enumerator.Dispose();
					}
				}
				return null;
			}
			set
			{
				try
				{
					IEnumerator<XElement> enumerator = source.GetEnumerator();
					if (enumerator.MoveNext())
					{
						XElement xelement = enumerator.Current;
						xelement.Value = value;
					}
				}
				finally
				{
					IEnumerator<XElement> enumerator;
					bool flag = enumerator != null;
					if (flag)
					{
						enumerator.Dispose();
					}
				}
			}
		}

		// Token: 0x17000007 RID: 7
		// (get) Token: 0x06000014 RID: 20 RVA: 0x00193B70 File Offset: 0x00191F70
		// (set) Token: 0x06000015 RID: 21 RVA: 0x00193BD8 File Offset: 0x00191FD8
		public static string AttributeValue
		{
			get
			{
				try
				{
					IEnumerator<XElement> enumerator = source.GetEnumerator();
					if (enumerator.MoveNext())
					{
						XElement xelement = enumerator.Current;
						return (string)xelement.Attribute(name);
					}
				}
				finally
				{
					IEnumerator<XElement> enumerator;
					bool flag = enumerator != null;
					if (flag)
					{
						enumerator.Dispose();
					}
				}
				return null;
			}
			set
			{
				try
				{
					IEnumerator<XElement> enumerator = source.GetEnumerator();
					if (enumerator.MoveNext())
					{
						XElement xelement = enumerator.Current;
						xelement.SetAttributeValue(name, value);
					}
				}
				finally
				{
					IEnumerator<XElement> enumerator;
					bool flag = enumerator != null;
					if (flag)
					{
						enumerator.Dispose();
					}
				}
			}
		}

		// Token: 0x17000008 RID: 8
		// (get) Token: 0x06000016 RID: 22 RVA: 0x00193C38 File Offset: 0x00192038
		// (set) Token: 0x06000017 RID: 23 RVA: 0x00193C58 File Offset: 0x00192058
		public static string AttributeValue
		{
			get
			{
				return (string)source.Attribute(name);
			}
			set
			{
				source.SetAttributeValue(name, value);
			}
		}

		// Token: 0x06000018 RID: 24 RVA: 0x00193C68 File Offset: 0x00192068
		[EditorBrowsable(EditorBrowsableState.Never)]
		public static XAttribute CreateAttribute(XName name, object value)
		{
			bool flag = value == null;
			XAttribute result;
			if (flag)
			{
				result = null;
			}
			else
			{
				result = new XAttribute(name, RuntimeHelpers.GetObjectValue(value));
			}
			return result;
		}

		// Token: 0x06000019 RID: 25 RVA: 0x00193C94 File Offset: 0x00192094
		[EditorBrowsable(EditorBrowsableState.Never)]
		public static XAttribute CreateNamespaceAttribute(XName name, XNamespace ns)
		{
			XAttribute xattribute = new XAttribute(name, ns.NamespaceName);
			xattribute.AddAnnotation(ns);
			return xattribute;
		}

		// Token: 0x0600001A RID: 26 RVA: 0x00193CBC File Offset: 0x001920BC
		[EditorBrowsable(EditorBrowsableState.Never)]
		public static object RemoveNamespaceAttributes(string[] inScopePrefixes, XNamespace[] inScopeNs, List<XAttribute> attributes, object obj)
		{
			bool flag = obj != null;
			if (flag)
			{
				XElement xelement = obj as XElement;
				flag = (xelement != null);
				if (flag)
				{
					return InternalXmlHelper.RemoveNamespaceAttributes(inScopePrefixes, inScopeNs, attributes, xelement);
				}
				IEnumerable enumerable = obj as IEnumerable;
				flag = (enumerable != null);
				if (flag)
				{
					return InternalXmlHelper.RemoveNamespaceAttributes(inScopePrefixes, inScopeNs, attributes, enumerable);
				}
			}
			return obj;
		}

		// Token: 0x0600001B RID: 27 RVA: 0x00193D1C File Offset: 0x0019211C
		[EditorBrowsable(EditorBrowsableState.Never)]
		public static IEnumerable RemoveNamespaceAttributes(string[] inScopePrefixes, XNamespace[] inScopeNs, List<XAttribute> attributes, IEnumerable obj)
		{
			bool flag = obj != null;
			IEnumerable result;
			if (flag)
			{
				IEnumerable<XElement> enumerable = obj as IEnumerable<XElement>;
				flag = (enumerable != null);
				if (flag)
				{
					result = enumerable.Select(new Func<XElement, XElement>(new InternalXmlHelper.RemoveNamespaceAttributesClosure(inScopePrefixes, inScopeNs, attributes).ProcessXElement));
				}
				else
				{
					result = obj.Cast<object>().Select(new Func<object, object>(new InternalXmlHelper.RemoveNamespaceAttributesClosure(inScopePrefixes, inScopeNs, attributes).ProcessObject));
				}
			}
			else
			{
				result = obj;
			}
			return result;
		}

		// Token: 0x0600001C RID: 28 RVA: 0x00193D90 File Offset: 0x00192190
		[EditorBrowsable(EditorBrowsableState.Never)]
		public static XElement RemoveNamespaceAttributes(string[] inScopePrefixes, XNamespace[] inScopeNs, List<XAttribute> attributes, XElement e)
		{
			bool flag = e != null;
			checked
			{
				if (flag)
				{
					XAttribute nextAttribute;
					for (XAttribute xattribute = e.FirstAttribute; xattribute != null; xattribute = nextAttribute)
					{
						nextAttribute = xattribute.NextAttribute;
						flag = xattribute.IsNamespaceDeclaration;
						if (flag)
						{
							XNamespace xnamespace = xattribute.Annotation<XNamespace>();
							string localName = xattribute.Name.LocalName;
							flag = (xnamespace != null);
							if (flag)
							{
								bool flag2 = inScopePrefixes != null && inScopeNs != null;
								if (flag2)
								{
									int num = inScopePrefixes.Length - 1;
									int num2 = 0;
									int num3 = num;
									int num4 = num2;
									XNamespace right;
									for (;;)
									{
										int num5 = num4;
										int num6 = num3;
										if (num5 > num6)
										{
											goto IL_BF;
										}
										string value = inScopePrefixes[num4];
										right = inScopeNs[num4];
										flag2 = localName.Equals(value);
										if (flag2)
										{
											break;
										}
										num4++;
									}
									flag = (xnamespace == right);
									if (flag)
									{
										xattribute.Remove();
									}
									xattribute = null;
								}
								IL_BF:
								flag2 = (xattribute != null);
								if (flag2)
								{
									flag = (attributes != null);
									bool flag3;
									if (flag)
									{
										int num7 = attributes.Count - 1;
										int num8 = 0;
										int num9 = num7;
										int num10 = num8;
										XNamespace xnamespace2;
										for (;;)
										{
											int num11 = num10;
											int num6 = num9;
											if (num11 > num6)
											{
												goto IL_15C;
											}
											XAttribute xattribute2 = attributes[num10];
											string localName2 = xattribute2.Name.LocalName;
											xnamespace2 = xattribute2.Annotation<XNamespace>();
											flag2 = (xnamespace2 != null);
											if (flag2)
											{
												flag = localName.Equals(localName2);
												if (flag)
												{
													break;
												}
											}
											num10++;
										}
										flag3 = (xnamespace == xnamespace2);
										if (flag3)
										{
											xattribute.Remove();
										}
										xattribute = null;
									}
									IL_15C:
									flag3 = (xattribute != null);
									if (flag3)
									{
										xattribute.Remove();
										attributes.Add(xattribute);
									}
								}
							}
						}
					}
				}
				return e;
			}
		}

		// Token: 0x02000008 RID: 8
		[DebuggerNonUserCode]
		[EditorBrowsable(EditorBrowsableState.Never)]
		[CompilerGenerated]
		private sealed class RemoveNamespaceAttributesClosure
		{
			// Token: 0x0600001D RID: 29 RVA: 0x00193F34 File Offset: 0x00192334
			[EditorBrowsable(EditorBrowsableState.Never)]
			internal RemoveNamespaceAttributesClosure(string[] inScopePrefixes, XNamespace[] inScopeNs, List<XAttribute> attributes)
			{
				this.m_inScopePrefixes = inScopePrefixes;
				this.m_inScopeNs = inScopeNs;
				this.m_attributes = attributes;
			}

			// Token: 0x0600001E RID: 30 RVA: 0x00193F54 File Offset: 0x00192354
			[EditorBrowsable(EditorBrowsableState.Never)]
			internal XElement ProcessXElement(XElement elem)
			{
				return InternalXmlHelper.RemoveNamespaceAttributes(this.m_inScopePrefixes, this.m_inScopeNs, this.m_attributes, elem);
			}

			// Token: 0x0600001F RID: 31 RVA: 0x00193F80 File Offset: 0x00192380
			[EditorBrowsable(EditorBrowsableState.Never)]
			internal object ProcessObject(object obj)
			{
				XElement xelement = obj as XElement;
				bool flag = xelement != null;
				object result;
				if (flag)
				{
					result = InternalXmlHelper.RemoveNamespaceAttributes(this.m_inScopePrefixes, this.m_inScopeNs, this.m_attributes, xelement);
				}
				else
				{
					result = obj;
				}
				return result;
			}

			// Token: 0x04000006 RID: 6
			private readonly string[] m_inScopePrefixes;

			// Token: 0x04000007 RID: 7
			private readonly XNamespace[] m_inScopeNs;

			// Token: 0x04000008 RID: 8
			private readonly List<XAttribute> m_attributes;
		}
	}
}
